// Version 2.0
// 1. Ethernet was added
// 2. MCP23s18 pins were changed

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "MDR32F9Qx_uart.h"
#include "clk.h"
#include "itmr.h"
#include "led.h"
#include "button.h"
#include "encoder.h"
#include "uart.h"
#include "terminal.h"
#include "buzzer.h"
#include "disp.h"
#include "rtc.h"
#include "console.h"
#include "wnds.h"
#include "intro.h"
#include "mcp23s18.h"
#include "MDR32F9Qx_timer.h"
#include "eth.h"
#include "eth_drv.h"
#include "mouse.h"
#include "keyboard.h"
#include "adc.h"
#include "dac.h"
#include "rs485.h"
#include "can.h"
#include "wdt.h"
#include "MDR32F9Qx_iwdg.h"
#include "main.h"

#include "MDR32F9Qx_port.h"
#include "hy28b_drv.h"

extern char wnd_choose = 2;

void Timer2_IRQHandler(void)
{	
	if(TIMER_GetITStatus(MDR_TIMER2, TIMER_STATUS_CCR_CAP_CH1) == SET){
		TIMER_ClearFlag(MDR_TIMER2, TIMER_STATUS_CCR_CAP_CH1);		
		if (wnd_choose == 1)
		{
			led_Toggle(5);
		  encoder_IRQProc();
					
		}
		if (wnd_choose == 2)
		{
			mouse_IRQProc();			
		}
		if (wnd_choose == 3)
		{
			led_Toggle(7);
			keyboard_IRQProc();
		}
		
		
	}	
}
void ADC_Handler(void)
{		
	adc_IRQ();	
}
int main(void)
{ 
	
	clk_CoreConfig();
	rtc_Init();
	
	itmr_Init();	
	led_Init();
	button_Init();	
	adc_Init();
	dac_Init();
	rs485_Init();
	can_Init();
	
	
	uart_Init(115200, UART_WordLength8b, UART_StopBits1, UART_Parity_No);	
	terminal_Init();
	
	mouse_Init();

	mcp23s18_Init();
	ethernet_LowLevelInit();
	disp_Init();	
	intro_Init();
	
	buzzer_Init();
	console_Init();
	wnd_Main();
	wdt_Init();
	rtc_Init();
	
	
  while(1){		
	
		rtc_Work();
	
		
		console_Work();
		
		led_Work();
		
		buzzer_Work();
		eth_FrameProcessing();
		
		wdt_ReLoad();
  }
	
}
