//#include "MDR1986VE1T.h"

#include "MDR32Fx.h"

#include "MDR32F9Qx_rst_clk.h"
#include "MDR32F9Qx_port.h"
#include "MDR32F9Qx_timer.h"

#include "MDR1986VE92QI_IT.h"

#include "timcap.h"

void timcap1_Init(void)
{	
	// 
	PORT_InitTypeDef PORT_InitStructure;
	
	TIMER_CntInitTypeDef sTIM_CntInit;	
	TIMER_ChnInitTypeDef ChnInitStruct;	
	RST_CLK_PCLKcmd(RST_CLK_PCLK_RST_CLK | RST_CLK_PCLK_PORTA | RST_CLK_PCLK_TIMER2, ENABLE);

	PORT_InitStructure.PORT_OE = PORT_OE_IN;
	PORT_InitStructure.PORT_PULL_UP = PORT_PULL_UP_OFF;
	PORT_InitStructure.PORT_PULL_DOWN = PORT_PULL_DOWN_OFF;
	PORT_InitStructure.PORT_FUNC = PORT_FUNC_OVERRID;
	PORT_InitStructure.PORT_MODE = PORT_MODE_DIGITAL;
	PORT_InitStructure.PORT_SPEED = PORT_SPEED_MAXFAST;
	
	PORT_InitStructure.PORT_Pin = PORT_Pin_1;	
	PORT_Init(MDR_PORTA, &PORT_InitStructure);	
	
	// 
	TIMER_BRGInit(MDR_TIMER2, TIMER_HCLKdiv2);	
	sTIM_CntInit.TIMER_IniCounter = 0;
	sTIM_CntInit.TIMER_Prescaler = 0;
	sTIM_CntInit.TIMER_Period = 0xFF;
	sTIM_CntInit.TIMER_CounterDirection = TIMER_CntDir_Up;
	sTIM_CntInit.TIMER_CounterMode = TIMER_CntMode_ClkFixedDir;
	sTIM_CntInit.TIMER_EventSource = TIMER_EvSrc_None;
	TIMER_CntInit(MDR_TIMER2, &sTIM_CntInit);
	
	TIMER_ChnStructInit(&ChnInitStruct);	
	ChnInitStruct.TIMER_CH_Number = TIMER_CHANNEL1; 
	ChnInitStruct.TIMER_CH_Mode = TIMER_CH_MODE_CAPTURE;
	ChnInitStruct.TIMER_CH_EventSource = TIMER_CH_EvSrc_NE;
	TIMER_ChnInit(MDR_TIMER2, &ChnInitStruct);

	TIMER_ITConfig(MDR_TIMER2, TIMER_STATUS_CCR_CAP_CH1, ENABLE);	
	NVIC_SetPriority(Timer2_IRQn, 0);
	NVIC_EnableIRQ(Timer2_IRQn);
	
	TIMER_Cmd(MDR_TIMER2, ENABLE);	
}

void timcap1_DeInit(void)
{
	TIMER_ITConfig(MDR_TIMER2, TIMER_STATUS_CCR_CAP_CH1, DISABLE);
	NVIC_DisableIRQ(Timer2_IRQn);
	TIMER_Cmd(MDR_TIMER2, DISABLE);	
}
/*
void timcap4_Init(void)
{	
	// 
	PORT_InitTypeDef PORT_InitStructure;
	
	TIMER_CntInitTypeDef sTIM_CntInit;	
	TIMER_ChnInitTypeDef ChnInitStruct;	
	RST_CLK_PCLKcmd(RST_CLK_PCLK_RST_CLK | RST_CLK_PCLK_PORTA | RST_CLK_PCLK_TIMER4, ENABLE);

	PORT_InitStructure.PORT_OE = PORT_OE_IN;
	PORT_InitStructure.PORT_FUNC = PORT_FUNC_ALTER;
	PORT_InitStructure.PORT_PULL_DOWN = PORT_PULL_DOWN_ON;
	PORT_InitStructure.PORT_MODE = PORT_MODE_DIGITAL;
	PORT_InitStructure.PORT_SPEED = PORT_SPEED_SLOW;
	
	PORT_InitStructure.PORT_Pin = PORT_Pin_10;	
	PORT_Init(MDR_PORTA, &PORT_InitStructure);	
	
	// 
	TIMER_BRGInit(MDR_TIMER4, TIMER_HCLKdiv1);	
	sTIM_CntInit.TIMER_IniCounter = 0;
	sTIM_CntInit.TIMER_Prescaler = 0;
	sTIM_CntInit.TIMER_Period = 0xFF;
	sTIM_CntInit.TIMER_CounterDirection = TIMER_CntDir_Up;
	sTIM_CntInit.TIMER_CounterMode = TIMER_CntMode_ClkFixedDir;
	sTIM_CntInit.TIMER_EventSource = TIMER_EvSrc_None;
	TIMER_CntInit(MDR_TIMER4, &sTIM_CntInit);
	
	TIMER_ChnStructInit(&ChnInitStruct);	
	ChnInitStruct.TIMER_CH_Number = TIMER_CHANNEL3; 
	ChnInitStruct.TIMER_CH_Mode = TIMER_CH_MODE_CAPTURE;
	ChnInitStruct.TIMER_CH_EventSource = TIMER_CH_EvSrc_NE;
	TIMER_ChnInit(MDR_TIMER4, &ChnInitStruct);

	TIMER_ITConfig(MDR_TIMER4, TIMER_STATUS_CCR_CAP_CH3, ENABLE);	
	NVIC_SetPriority(TIMER4_IRQn, 0);
	NVIC_EnableIRQ(TIMER4_IRQn);
	
	TIMER_Cmd(MDR_TIMER4, ENABLE);	
}

void timcap4_DeInit(void)
{
	TIMER_ITConfig(MDR_TIMER4, TIMER_STATUS_CCR_CAP_CH3, DISABLE);	
	NVIC_DisableIRQ(TIMER4_IRQn);
	TIMER_Cmd(MDR_TIMER4, DISABLE);	
}
*/
