#include <string.h>
#include "itmr.h"
#include "console.h"
#include "wnds.h"
#include "eth_drv.h"

static TEthSettings EthSettings;

static TWENumEdit neMASK1 = { 0, 0, 255, 3 };
static TWENumEdit neMASK2 = { 0, 0, 255, 3 };
static TWENumEdit neMASK3 = { 0, 0, 255, 3 };
static TWENumEdit neMASK4 = { 0, 0, 255, 3 };

BEGIN_WE_TABLE(ElemTable)
	DEFINE_WE(WET_NUM_EDIT,	0, 0, 0, "MASK1: ", &neMASK1)
	DEFINE_WE(WET_NUM_EDIT, 0, 1, 0, "MASK2: ", &neMASK2)  	
	DEFINE_WE(WET_NUM_EDIT, 0, 2, 0, "MASK3: ", &neMASK3)  
	DEFINE_WE(WET_NUM_EDIT, 0, 3, 0, "MASK4: ", &neMASK4)  	 
END_WE_TABLE()

static bool EventProc(unsigned int code, unsigned int data);

static TWnd Wnd = { WID_ETH_MASK, ElemTable, EventProc, 0 };

static bool EventProc(unsigned int code, unsigned int data)
{
  switch (code) {
    case WE_DRAW:
      if (data == 0) {
				NumEdit_SetVal(&neMASK1, EthSettings.mask[0]);
				NumEdit_SetVal(&neMASK2, EthSettings.mask[1]);
				NumEdit_SetVal(&neMASK3, EthSettings.mask[2]);
				NumEdit_SetVal(&neMASK4, EthSettings.mask[3]);		
      }
      break;
		case WE_EDIT_END:
			switch(Wnd.cur_elem){
				case 0:
					EthSettings.mask[0] = neMASK1.cur_val;
					break;
				case 1:
					EthSettings.mask[1] = neMASK2.cur_val;
					break;
				case 2:
					EthSettings.mask[2] = neMASK3.cur_val;
					break;
				case 3:
					EthSettings.mask[3] = neMASK4.cur_val;
					break;				
			}
			ethernet_SetSettings(&EthSettings);
			break;
  }

  return false;
}

void wnd_EthMASK(void)
{ 
	ethernet_GetSettings(&EthSettings);
  console_OpenWnd(&Wnd);
}
